
<h4 class="light">A Distributed Social Platform for users that care about
controlling their data.</h4>

<div class="row">

<div class="four columns">

<div class="head-icon"><i class="fa fa-upload fa-3x light"></i></div>

#### Share

__Upload your media, write your posts and share your files__. The more people see it,
the more it spreads.

</div>

<div class="four columns">

<div class="head-icon"><i class="fa fa-globe fa-3x light"></i></div>

#### Discover

__Anyone can seed a copy of everything__,
App included. You can even use it
in LANs without the Internet.

</div>

<div class="four columns">

<div class="head-icon"><i class="fa fa-users fa-3x light"></i></div>

#### Connect

__Take advantage of the social features__: seed what you like, leave comments
and build communities together.

</div>
</div>

</div>

---

# Why?

<h4 class="light">Because existing social platforms are broken</h4>

<div class="row">

<div class="six columns">

<div class="head-icon"><i class="fa fa-server fa-3x light"></i></div>

#### Centralized

__Online services are all centralized__. Your data always goes through foreign servers and
is stored in databases far away from your control.

</div>
<div class="six columns">

<div class="head-icon"><i class="fa fa-money fa-3x light"></i></div>

#### Expensive

__Centralization costs a lot__. Servers need to be paid for and engineers need to
be hired to handle their load. __That's why most sites have ads__.

</div>
</div>

<div class="row">
<div class="six columns">

<div class="head-icon"><i class="fa fa-bomb fa-3x light"></i></div>

#### Fragile

When you use a centralized service, you rely on its owners. __What if they go
bankrupt or just pull the plug on your data?__

</div>
<div class="six columns">

<div class="head-icon"><i class="fa fa-legal fa-3x light"></i></div>

#### Controlled

__The owners control the service__. What if you want to go back to an older version
of the service? What if you want it to work like it used to, or you want to make
it do something new?

</div>
</div>

----

## How do we solve it

<h5 class="light">Boards was designed to be Distributed from scratch,
using the <a href="https://ipfs.io">IPFS</a> protocol.</h5>

<div class="row">
<div class="six columns">

<div class="head-icon"><i class="fa fa-users fa-3x light"></i></div>

#### Distributed

__Every user hosts is own data__, but your computer
helps your friends and favorite creators (and only them) by seeding their content,
sending it to whoever wants to see it. Anyone can also set up a server that
helps random users by seeding their data.

</div>
<div class="six columns">

<div class="head-icon"><i class="fa fa-bolt fa-3x light"></i></div>

#### Efficient

There is no heavy __Blockchain__. This service is built to work everywhere from
supercomputers to smartphones to embedded devices. __The more users see a page,
the faster it travels to others__, making Denial of Service attacks very hard and
allowing users to work offline.

</div>
</div>

<div class="row">
<div class="six columns">

<div class="head-icon"><i class="fa fa-globe fa-3x light"></i></div>

#### Free

__Free, as in Freedom__. __We can't control anything__, because the users
control the content. There is no central database. There are only the users,
their computers, and their content. __We can't put ads on this__, because
they'd be too easy to block: anyone can create his own App that connects to
our service.

</div>
<div class="six columns">

<div class="head-icon"><i class="fa fa-cogs fa-3x light"></i></div>

#### Open

__We're working on this in the open__. We already have a prototype, and all our
code is _Free Software_. Got what it
takes? [Join development on GitHub](https://github.com/fazo96/ipfs-boards) and
help us making this better. __There are a lot of ways you can help__: not only writing code,
but also submitting feedback, testing for bugs, and spreading the word.

</div>
</div>

----

<h5 class="light">Learn more about development</h5>

<a href="https://github.com/fazo96/ipfs-boards"><i class="fa fa-github fa-3x"></i></a>

__Note:__ a getting started section is coming as soon as the prototype is ready!

----

Built by [Enrico Fasoli](https://github.com/fazo96). This Application is
distributed under the terms of the MIT License. Every other bundled asset is
distributed under the terms of its own license. Learn more at the
[Project Page](https://github.com/fazo96/ipfs-boards)

<i class="fa fa-fort-awesome light"></i> Icons by [FontAwesome](https://fontawesome.io) <i class="fa fa-fort-awesome light"></i>
